--- src/backend/storage/buffer/bufmgr.c.orig	2014-08-18 14:10:36.937017089 -0400
+++ src/backend/storage/buffer/bufmgr.c	2014-08-19 16:56:13.515196557 -0400
@@ -1041,18 +1354,18 @@ ReleaseAndReadBuffer(Buffer buffer,
 					 Relation relation,
 					 BlockNumber blockNum)
 {
-	ForkNumber	forkNum = MAIN_FORKNUM;
 	volatile BufferDesc *bufHdr;
+        bool isDifferentBlock;   /*       requesting different block from that already in buffer ? */
 
 	if (BufferIsValid(buffer))
 	{
+	    /* if a shared buff, we have pin, so it's ok to examine tag without spinlock */
+            isDifferentBlock = BlocknotinBuffer(buffer,relation,blockNum); /*  requesting different block from that already in buffer ? */
 		if (BufferIsLocal(buffer))
 		{
 			Assert(LocalRefCount[-buffer - 1] > 0);
 			bufHdr = &LocalBufferDescriptors[-buffer - 1];
-			if (bufHdr->tag.blockNum == blockNum &&
-				RelFileNodeEquals(bufHdr->tag.rnode, relation->rd_node) &&
-				bufHdr->tag.forkNum == forkNum)
+			if (!isDifferentBlock)
 				return buffer;
 			ResourceOwnerForgetBuffer(CurrentResourceOwner, buffer);
 			LocalRefCount[-buffer - 1]--;
@@ -1061,12 +1374,12 @@ ReleaseAndReadBuffer(Buffer buffer,
 		{
 			Assert(PrivateRefCount[buffer - 1] > 0);
 			bufHdr = &BufferDescriptors[buffer - 1];
-			/* we have pin, so it's ok to examine tag without spinlock */
-			if (bufHdr->tag.blockNum == blockNum &&
-				RelFileNodeEquals(bufHdr->tag.rnode, relation->rd_node) &&
-				bufHdr->tag.forkNum == forkNum)
+                        BufCheckAsync(0 , relation , bufHdr , ( isDifferentBlock ? BUF_INTENTION_REJECT_FORGET
+                                                                                 : BUF_INTENTION_REJECT_KEEP_PIN )
+                                                            , 0 , 0 , false , 0 ); /* end any IO and maybe unpin */
+			if (!isDifferentBlock) {
 				return buffer;
-			UnpinBuffer(bufHdr, true);
+                        }
 		}
 	}
 
@@ -1091,11 +1404,12 @@ ReleaseAndReadBuffer(Buffer buffer,
  * Returns TRUE if buffer is BM_VALID, else FALSE.  This provision allows
  * some callers to avoid an extra spinlock cycle.
  */
-static bool
+bool
 PinBuffer(volatile BufferDesc *buf, BufferAccessStrategy strategy)
 {
 	int			b = buf->buf_id;
 	bool		result;
+        bool       pin_already_banked_by_me = 0;  /* buffer is already pinned by me and redeemable */
 
 	if (PrivateRefCount[b] == 0)
 	{
@@ -1117,12 +1431,34 @@ PinBuffer(volatile BufferDesc *buf, Buff
 	else
 	{
 		/* If we previously pinned the buffer, it must surely be valid */
+                /* Errr  -   is that really true  ???    I don't think so  :
+                ** what if I pin,  try an IO,  in progress,  then mistakenly pin again
 		result = true;
+                */
+		LockBufHdr(buf);
+                pin_already_banked_by_me = (    (PrivateRefCount[b] > 0) && (buf->flags & BM_AIO_PREFETCH_PIN_BANKED)
+                                             && (   (    (buf->flags & BM_AIO_IN_PROGRESS) ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext))->pidOfAio )
+                                                                                     : (-(buf->freeNext))  )  == this_backend_pid )
+                                           );
+                if (pin_already_banked_by_me) {
+                        elog(LOG, "PinBuffer : on buffer %d with banked pin rel=%s, blockNum=%u, with flags %X refcount=%u"
+                       ,buf->buf_id,relpathbackend(buf->tag.rnode, InvalidBackendId, buf->tag.forkNum)
+                       ,buf->tag.blockNum, buf->flags, buf->refcount);
+                    buf->flags &= ~BM_AIO_PREFETCH_PIN_BANKED;
+                    if (!(buf->flags & BM_AIO_IN_PROGRESS)) {
+                        buf->freeNext = FREENEXT_NOT_IN_LIST;      /*  forget the bank client */
 	}
+                }
+		result = (buf->flags & BM_VALID) != 0;
+		UnlockBufHdr(buf);
+	}
+
+        if (!pin_already_banked_by_me) {
 	PrivateRefCount[b]++;
 	Assert(PrivateRefCount[b] > 0);
 	ResourceOwnerRememberBuffer(CurrentResourceOwner,
 								BufferDescriptorGetBuffer(buf));
+        }
 	return result;
 }
 
@@ -1139,19 +1475,36 @@ PinBuffer(volatile BufferDesc *buf, Buff
  * to save a spin lock/unlock cycle, because we need to pin a buffer before
  * its state can change under us.
  */
-static void
+void
 PinBuffer_Locked(volatile BufferDesc *buf)
 {
 	int			b = buf->buf_id;
+        bool       pin_already_banked_by_me;  /* buffer is already pinned by me and redeemable */
 
-	if (PrivateRefCount[b] == 0)
+        pin_already_banked_by_me = (    (PrivateRefCount[b] > 0) && (buf->flags & BM_AIO_PREFETCH_PIN_BANKED)
+                                     && (   (    (buf->flags & BM_AIO_IN_PROGRESS) ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext))->pidOfAio )
+                                                                             : (-(buf->freeNext))  )  == this_backend_pid )
+                             );
+	if (PrivateRefCount[b] == 0) {
 		buf->refcount++;
+        }
+        if (pin_already_banked_by_me) {
+                        elog(LOG, "PinBuffer_Locked : on buffer %d with banked pin rel=%s, blockNum=%u, with flags %X refcount=%u"
+                       ,buf->buf_id,relpathbackend(buf->tag.rnode, InvalidBackendId, buf->tag.forkNum)
+                       ,buf->tag.blockNum, buf->flags, buf->refcount);
+            buf->flags &= ~BM_AIO_PREFETCH_PIN_BANKED;
+                    if (!(buf->flags & BM_AIO_IN_PROGRESS)) {
+                        buf->freeNext = FREENEXT_NOT_IN_LIST;      /*  forget the bank client */
+                    }
+        }
 	UnlockBufHdr(buf);
+        if (!pin_already_banked_by_me) {
 	PrivateRefCount[b]++;
 	Assert(PrivateRefCount[b] > 0);
 	ResourceOwnerRememberBuffer(CurrentResourceOwner,
 								BufferDescriptorGetBuffer(buf));
 }
+}
 
 /*
  * UnpinBuffer -- make buffer available for replacement.
@@ -1161,29 +1514,68 @@ PinBuffer_Locked(volatile BufferDesc *bu
  * Most but not all callers want CurrentResourceOwner to be adjusted.
  * Those that don't should pass fixOwner = FALSE.
  */
-static void
+void
 UnpinBuffer(volatile BufferDesc *buf, bool fixOwner)
 {
+
 	int			b = buf->buf_id;
+        bool       pin_already_banked_by_me;  /* buffer is already pinned by me and redeemable */
 
-	if (fixOwner)
+	if (fixOwner) {
 		ResourceOwnerForgetBuffer(CurrentResourceOwner,
 								  BufferDescriptorGetBuffer(buf));
+        }
 
 	Assert(PrivateRefCount[b] > 0);
 	PrivateRefCount[b]--;
 	if (PrivateRefCount[b] == 0)
 	{
+
 		/* I'd better not still hold any locks on the buffer */
 		Assert(!LWLockHeldByMe(buf->content_lock));
 		Assert(!LWLockHeldByMe(buf->io_in_progress_lock));
 
 		LockBufHdr(buf);
 
+		/* this backend has released last pin - buffer should not have pin banked by me
+                ** and if AIO in progress then there should be another backend pin
+                */
+                pin_already_banked_by_me = (       (buf->flags & BM_AIO_PREFETCH_PIN_BANKED)
+                                             &&    (   (    (buf->flags & BM_AIO_IN_PROGRESS)
+                                                         ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext))->pidOfAio )
+                                                         : (-(buf->freeNext))
+                                                       )  == this_backend_pid )
+                                           );
+                if (pin_already_banked_by_me) {
+                        /*  this is a strange situation  -  caller had a banked pin (which callers are supposed not to know about)
+                        **                                  but either discovered it had it or has over-counted how many pins it has
+                        */
+                        buf->flags &= ~BM_AIO_PREFETCH_PIN_BANKED;   /*   redeem the pin although it is now of no use since about to release */
+                        if (!(buf->flags & BM_AIO_IN_PROGRESS)) {
+                            buf->freeNext = FREENEXT_NOT_IN_LIST;      /*  forget the bank client */
+                        }
+
+                        /*     temporarily suppress logging error to avoid performance degradation -
+                        **     either this task really does not need the buffer in which case the error is harmless
+                        **     or a more severe error will be detected later (possibly immediately below)
+                        elog(LOG, "UnpinBuffer :  released last this-backend pin on buffer %d rel=%s, blockNum=%u, but had banked pin flags %X refcount=%u"
+                       ,buf->buf_id,relpathbackend(buf->tag.rnode, InvalidBackendId, buf->tag.forkNum)
+                       ,buf->tag.blockNum, buf->flags, buf->refcount);
+                        */
+                }
+
 		/* Decrement the shared reference count */
 		Assert(buf->refcount > 0);
 		buf->refcount--;
 
+                if (   (buf->refcount == 0) && (buf->flags & BM_AIO_IN_PROGRESS)  ) {
+
+                        elog(ERROR, "UnpinBuffer :  released last any-backend pin on buffer %d rel=%s, blockNum=%u, but AIO in progress flags %X refcount=%u"
+                            ,buf->buf_id,relpathbackend(buf->tag.rnode, InvalidBackendId, buf->tag.forkNum)
+                            ,buf->tag.blockNum, buf->flags, buf->refcount);
+                }
+
+
 		/* Support LockBufferForCleanup() */
 		if ((buf->flags & BM_PIN_COUNT_WAITER) &&
 			buf->refcount == 1)
@@ -1658,6 +2050,7 @@ SyncOneBuffer(int buf_id, bool skip_rece
 	volatile BufferDesc *bufHdr = &BufferDescriptors[buf_id];
 	int			result = 0;
 
+
 	/*
 	 * Check whether buffer needs writing.
 	 *
@@ -1724,6 +2117,16 @@ void
 InitBufferPoolBackend(void)
 {
 	on_shmem_exit(AtProcExit_Buffers, 0);
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        /*   init the aio subsystem max number of threads and max number of requests
+        **   max number of threads   <-->  max_async_io_prefetchers
+        **   max number of requests  <-->  numBufferAiocbs = (target_prefetch_pages*max_async_io_prefetchers)
+        **   there is no return code so we just hope.
+        */
+        smgrinitaio(max_async_io_prefetchers , numBufferAiocbs);
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 }
 
 /*
@@ -1736,6 +2139,11 @@ AtProcExit_Buffers(int code, Datum arg)
 	AbortBufferIO();
 	UnlockBuffers();
 
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on BAiocb lock instead of polling */
+    elog(LOG,"backend %d started %ld aios , cancelled %ld , signalled %ld\n"
+           ,this_backend_pid,num_startedaio,num_cancelledaio ,num_signalledaio);
+#endif /*  USE_AIO_SIGEVENT    */
+
 	CheckForBufferLeaks();
 
 	/* localbuf.c needs a chance too */
@@ -1779,6 +2187,8 @@ PrintBufferLeakWarning(Buffer buffer)
 	char	   *path;
 	BackendId	backend;
 
+
+
 	Assert(BufferIsValid(buffer));
 	if (BufferIsLocal(buffer))
 	{
@@ -1789,12 +2199,28 @@ PrintBufferLeakWarning(Buffer buffer)
 	else
 	{
 		buf = &BufferDescriptors[buffer - 1];
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                /*   If reason that this buffer is pinned
+                **   is that it was prefetched with async_io
+                **   and never read or discarded, then omit the
+                **   warning,  because this is expected in some
+                **   cases when a scan is closed abnormally.
+                **   Note that the buffer will be released soon by our caller.
+                */
+                if (buf->flags & BM_AIO_PREFETCH_PIN_BANKED) {
+                    pgBufferUsage.aio_read_forgot++; /* account for it */
+                    return;
+                }
+#endif /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 		loccount = PrivateRefCount[buffer - 1];
 		backend = InvalidBackendId;
 	}
 
+/* #if defined(DO_ISCAN_DISCARD_BUFFER) && defined(DO_HEAPSCAN_DISCARD_BUFFER) not yet working safely 130530 */
 	/* theoretically we should lock the bufhdr here */
 	path = relpathbackend(buf->tag.rnode, backend, buf->tag.forkNum);
+
+
 	elog(WARNING,
 		 "buffer refcount leak: [%03d] "
 		 "(rel=%s, blockNum=%u, flags=0x%x, refcount=%u %d)",
@@ -1802,6 +2228,7 @@ PrintBufferLeakWarning(Buffer buffer)
 		 buf->tag.blockNum, buf->flags,
 		 buf->refcount, loccount);
 	pfree(path);
+/* #endif defined(DO_ISCAN_DISCARD_BUFFER) && defined(DO_HEAPSCAN_DISCARD_BUFFER) not yet working safely 130530 */
 }
 
 /*
@@ -1918,7 +2345,7 @@ FlushBuffer(volatile BufferDesc *buf, SM
 	 * false, then someone else flushed the buffer before we could, so we need
 	 * not do anything.
 	 */
-	if (!StartBufferIO(buf, false))
+	if (!StartBufferIO(buf, false, 0))
 		return;
 
 	/* Setup error traceback support for ereport() */
@@ -2502,6 +2929,70 @@ FlushDatabaseBuffers(Oid dbid)
 	}
 }
 
+#ifdef USE_PREFETCH
+/*
+ * DiscardBuffer -- discard shared buffer used for a previously
+ *                  prefetched but unread block of a relation
+ *
+ * If the buffer is found and pinned with a banked pin,  then :
+ *      .  if AIO in progress, terminate AIO without waiting
+ *      .  if AIO had already completed successfully,
+ *         then mark buffer valid (in case someone else wants it)
+ *      .  redeem the banked pin and unpin it.
+ *
+ * This function is similar in purpose to ReleaseBuffer (below)
+ * but sufficiently different that it is a separate function.
+ * Two important differences are :
+ *   .   caller identifies buffer by blocknumber,  not buffer number
+ *   .   we unpin buffer *only* if the pin is banked,
+ *                      *never* if pinned but not banked.
+ *       This is essential as caller may perform a sequence of
+ *  SCAN1   . PrefetchBuffer   (and remember block was prefetched)
+ *  SCAN2   . ReadBuffer       (but fails to connect this read to the prefetch by SCAN1)
+ *  SCAN1   . DiscardBuffer    (SCAN1 terminates early)
+ *  SCAN2   . access tuples in buffer
+ *        Clearly the Discard *must not* unpin the buffer since SCAN2 needs it!
+ *
+ *
+ * caller may pass InvalidBlockNumber as blockNum to mean do nothing
+ */
+void
+DiscardBuffer(Relation reln, ForkNumber forkNum, BlockNumber blockNum)
+{
+        BufferTag	newTag;		   /* identity of requested block */
+        uint32		newHash;	   /* hash value for newTag */
+        LWLockId	newPartitionLock;  /* buffer partition lock for it */
+        Buffer		buf_id;
+        volatile        BufferDesc *buf_desc;
+
+    if (!SmgrIsTemp(reln->rd_smgr)) {
+	Assert(RelationIsValid(reln));
+	if (BlockNumberIsValid(blockNum)) {
+
+            /* create a tag so we can lookup the buffer */
+            INIT_BUFFERTAG(newTag, reln->rd_smgr->smgr_rnode.node,
+                                       forkNum, blockNum);
+
+            /* determine its hash code and partition lock ID */
+            newHash = BufTableHashCode(&newTag);
+            newPartitionLock = BufMappingPartitionLock(newHash);
+
+            /* see if the block is in the buffer pool already */
+            LWLockAcquire(newPartitionLock, LW_SHARED);
+            buf_id = BufTableLookup(&newTag, newHash);
+            LWLockRelease(newPartitionLock);
+
+            /* If in buffers, proceed */
+            if (buf_id >= 0) {
+                buf_desc = &BufferDescriptors[buf_id];        /* found buffer descriptor */
+                BufCheckAsync(0 , reln, buf_desc , BUF_INTENTION_REJECT_UNBANK , 0 , 0 , false , 0); /* end the IO and unpin if banked */
+                pgBufferUsage.aio_read_discrd++; /* account for it */
+            }
+        }
+    }
+}
+#endif   /* USE_PREFETCH */
+
 /*
  * ReleaseBuffer -- release the pin on a buffer
  */
@@ -2510,26 +3001,23 @@ ReleaseBuffer(Buffer buffer)
 {
 	volatile BufferDesc *bufHdr;
 
+
 	if (!BufferIsValid(buffer))
 		elog(ERROR, "bad buffer ID: %d", buffer);
 
-	ResourceOwnerForgetBuffer(CurrentResourceOwner, buffer);
 
 	if (BufferIsLocal(buffer))
 	{
+                ResourceOwnerForgetBuffer(CurrentResourceOwner, buffer);
 		Assert(LocalRefCount[-buffer - 1] > 0);
 		LocalRefCount[-buffer - 1]--;
 		return;
 	}
-
-	bufHdr = &BufferDescriptors[buffer - 1];
-
-	Assert(PrivateRefCount[buffer - 1] > 0);
-
-	if (PrivateRefCount[buffer - 1] > 1)
-		PrivateRefCount[buffer - 1]--;
 	else
-		UnpinBuffer(bufHdr, false);
+        {
+                bufHdr = &BufferDescriptors[buffer - 1];
+                BufCheckAsync(0 , 0 , bufHdr , BUF_INTENTION_REJECT_NOADJUST , 0 , 0 , false , 0 );
+        }
 }
 
 /*
@@ -2555,14 +3043,41 @@ UnlockReleaseBuffer(Buffer buffer)
 void
 IncrBufferRefCount(Buffer buffer)
 {
+        bool       pin_already_banked_by_me = false;  /* buffer is already pinned by me and redeemable */
+        volatile BufferDesc *buf;                     /* descriptor for a shared buffer */
+
 	Assert(BufferIsPinned(buffer));
+
+        if (!(BufferIsLocal(buffer))) {
+                buf = &BufferDescriptors[buffer - 1];
+		LockBufHdr(buf);
+                pin_already_banked_by_me =
+                      (    (buf->flags & BM_AIO_PREFETCH_PIN_BANKED)
+                        && (   (    (buf->flags & BM_AIO_IN_PROGRESS) ? ( ((BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext))->pidOfAio )
+                                                                      : (-(buf->freeNext))  )  == this_backend_pid )
+                      );
+        }
+
+        if (!pin_already_banked_by_me) {
 	ResourceOwnerEnlargeBuffers(CurrentResourceOwner);
 	ResourceOwnerRememberBuffer(CurrentResourceOwner, buffer);
+        }
+
 	if (BufferIsLocal(buffer))
 		LocalRefCount[-buffer - 1]++;
-	else
+	else {
+                if (pin_already_banked_by_me) {
+                    buf->flags &= ~BM_AIO_PREFETCH_PIN_BANKED;
+                    if (!(buf->flags & BM_AIO_IN_PROGRESS)) {
+                        buf->freeNext = FREENEXT_NOT_IN_LIST;      /*  forget the bank client */
+                    }
+                }
+		UnlockBufHdr(buf);
+                if (!pin_already_banked_by_me) {
 		PrivateRefCount[buffer - 1]++;
 }
+        }
+}
 
 /*
  * MarkBufferDirtyHint
@@ -2984,61 +3499,138 @@ WaitIO(volatile BufferDesc *buf)
  *
  * In some scenarios there are race conditions in which multiple backends
  * could attempt the same I/O operation concurrently.  If someone else
- * has already started I/O on this buffer then we will block on the
+ * has already started synchronous I/O on this buffer then we will block on the
  * io_in_progress lock until he's done.
  *
+ * if an async io is in progress and we are doing synchronous io,
+ * then readbuffer uses call to smgrcompleteaio to wait,
+ * and so we treat this request as if no io in progress
+ *
  * Input operations are only attempted on buffers that are not BM_VALID,
  * and output operations only on buffers that are BM_VALID and BM_DIRTY,
  * so we can always tell if the work is already done.
  *
+ * index_for_aio is an input parm which,  if non-zero,  identifies a BufferAiocb
+ * acquired by caller and to be attached to the buffer header for use with async io
+ *
  * Returns TRUE if we successfully marked the buffer as I/O busy,
  * FALSE if someone else already did the work.
  */
 static bool
-StartBufferIO(volatile BufferDesc *buf, bool forInput)
+StartBufferIO(volatile BufferDesc *buf, bool forInput , int index_for_aio )
 {
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        struct BufferAiocb volatile * BAiocb = (struct BufferAiocb*)0;  /*  BufferAiocb for use with aio */
+#endif   /* USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+ 
+        if (!index_for_aio)
 	Assert(!InProgressBuf);
 
 	for (;;)
 	{
+                if (!index_for_aio) {
 		/*
 		 * Grab the io_in_progress lock so that other processes can wait for
 		 * me to finish the I/O.
 		 */
 		LWLockAcquire(buf->io_in_progress_lock, LW_EXCLUSIVE);
+                }
 
 		LockBufHdr(buf);
 
-		if (!(buf->flags & BM_IO_IN_PROGRESS))
+                /*     the following test is intended to distinguish between :
+                **      .   buffer which : 
+                **           .     has io in progress
+                **             AND is not associated with a current aio
+                **      .   not the above
+                **     Here,  "recent" means an aio marked by buf->freeNext <= FREENEXT_BAIOCB_ORIGIN but no longer in progress -
+                **          this situation arises when the aio has just been cancelled and this process now wishes to recycle the buffer.
+                **          In this case,  the first such would-be recycler (i.e. me) must :
+                **             . avoid waiting for the cancelled aio to complete
+                **             . if not myself doing async read, then assume responsibility for posting other future readbuffers.
+                */
+		if (    (buf->flags & BM_AIO_IN_PROGRESS)
+             || (!(buf->flags & BM_IO_IN_PROGRESS))
+           )
 			break;
 
 		/*
-		 * The only way BM_IO_IN_PROGRESS could be set when the io_in_progress
+		 * The only way BM_IO_IN_PROGRESS without AIO in progress could be set when the io_in_progress
 		 * lock isn't held is if the process doing the I/O is recovering from
 		 * an error (see AbortBufferIO).  If that's the case, we must wait for
 		 * him to get unwedged.
 		 */
 		UnlockBufHdr(buf);
+                if (!index_for_aio) {
 		LWLockRelease(buf->io_in_progress_lock);
+                }
 		WaitIO(buf);
 	}
 
-	/* Once we get here, there is definitely no I/O active on this buffer */
-
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+	/* Once we get here, there is definitely no synchronous I/O active on this buffer
+        ** but if being asked to attach a BufferAiocb to the buf header,
+        ** then we must also check if there is any async io currently
+        ** in progress or pinned started by a different task.
+        */
+        if (index_for_aio) {
+            BAiocb = (BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - buf->freeNext);
+            if (    (buf->flags & (BM_AIO_IN_PROGRESS|BM_AIO_PREFETCH_PIN_BANKED))
+                 && (buf->freeNext <= FREENEXT_BAIOCB_ORIGIN)
+                 && (BAiocb->pidOfAio != this_backend_pid)
+               ) {
+                    /* someone else already doing async I/O */
+                    UnlockBufHdr(buf);
+                    return false;
+            }
+	}
+#endif   /* USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 	if (forInput ? (buf->flags & BM_VALID) : !(buf->flags & BM_DIRTY))
 	{
 		/* someone else already did the I/O */
 		UnlockBufHdr(buf);
+                if (!index_for_aio) {
 		LWLockRelease(buf->io_in_progress_lock);
+                }
 		return false;
 	}
 
 	buf->flags |= BM_IO_IN_PROGRESS;
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        if (index_for_aio) {
+            BAiocb = (BAiocbAnchr->BufferAiocbs)+(FREENEXT_BAIOCB_ORIGIN - index_for_aio);
+            /*   insist that no other buffer is using this BufferAiocb for async IO */
+            if (BAiocb->BAiocbbufh == (struct sbufdesc *)0) {
+                BAiocb->BAiocbbufh = buf;
+            }
+            if (BAiocb->BAiocbbufh != buf) {
+                               ereport(ERROR,
+                                    (errcode(ERRCODE_INTERNAL_ERROR),
+                                     errmsg("AIO control block %p to be used by %p already in use by %p"
+                                              ,BAiocb ,buf , BAiocb->BAiocbbufh)));
+            }
+            /*   note - there is no need to register self as an dependent of BAiocb
+            **   as we shall not unlock buf_desc before we free the BAiocb
+            */
+
+            buf->flags |= BM_AIO_IN_PROGRESS;
+            buf->freeNext = index_for_aio;
+            /*  at this point,  this buffer appears to have an in-progress aio_read,
+            **  and any other task which is able to look inside the buffer might try waiting on that aio -
+            **  except we have not yet issued the aio!   So we must keep the buffer header locked
+            **  from here all the way back to the BufStartAsync caller
+            */
+        } else {
+#endif   /* USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 	UnlockBufHdr(buf);
 
 	InProgressBuf = buf;
 	IsForInput = forInput;
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        }
+#endif   /* USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 	return true;
 }
@@ -3048,7 +3640,7 @@ StartBufferIO(volatile BufferDesc *buf,
  *	(Assumptions)
  *	My process is executing IO for the buffer
  *	BM_IO_IN_PROGRESS bit is set for the buffer
- *	We hold the buffer's io_in_progress lock
+ *	if no async IO in progress,  then We hold the buffer's io_in_progress lock
  *	The buffer is Pinned
  *
  * If clear_dirty is TRUE and BM_JUST_DIRTIED is not set, we clear the
@@ -3060,26 +3652,32 @@ StartBufferIO(volatile BufferDesc *buf,
  * BM_IO_ERROR in a failure case.  For successful completion it could
  * be 0, or BM_VALID if we just finished reading in the page.
  */
-static void
+void
 TerminateBufferIO(volatile BufferDesc *buf, bool clear_dirty,
 				  int set_flag_bits)
 {
-	Assert(buf == InProgressBuf);
+        int flags_on_entry;
 
 	LockBufHdr(buf);
 
+        flags_on_entry = buf->flags;
+
+        if (! (flags_on_entry & BM_AIO_IN_PROGRESS) )
+            Assert( buf == InProgressBuf );
+
 	Assert(buf->flags & BM_IO_IN_PROGRESS);
-	buf->flags &= ~(BM_IO_IN_PROGRESS | BM_IO_ERROR);
+	buf->flags &= ~(BM_IO_IN_PROGRESS | BM_IO_ERROR | BM_AIO_IN_PROGRESS);
 	if (clear_dirty && !(buf->flags & BM_JUST_DIRTIED))
 		buf->flags &= ~(BM_DIRTY | BM_CHECKPOINT_NEEDED);
 	buf->flags |= set_flag_bits;
 
 	UnlockBufHdr(buf);
 
+        if (! (flags_on_entry & BM_AIO_IN_PROGRESS) ) {
 	InProgressBuf = NULL;
-
 	LWLockRelease(buf->io_in_progress_lock);
 }
+}
 
 /*
  * AbortBufferIO: Clean up any active buffer I/O after an error.
